routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    $products = App\Models\Product::with('category')->get();
    return view('welcome', compact('products'));
});

Auth::routes();

Route::group(['middleware' => ['auth']], function() {
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::resource('products', App\Http\Controllers\ProductController::class);
    Route::resource('categories', App\Http\Controllers\CategoryController::class);
});

app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Product extends Model
{
    use HasFactory;
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'description',
        'price',
        'category_id',
        'image',
    ];

    /**
     * Get the category that owns the comment.
     */
    public function category()
    {
        return $this->belongsTo(Category::class);
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use App\Models\Product;
use App\Http\Requests\StoreProductRequest;
use App\Http\Requests\UpdateProductRequest;
use App\DataTables\ProductsDataTable;
use Illuminate\Http\Request;
use Storage;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(ProductsDataTable $dataTable)
    {
        return $dataTable->render('products.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $product = new Product();
        // get list categories
        $categories = Category::pluck('name', 'id');
        
        return view('products.create', compact('product', 'categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \App\Http\Requests\StoreProductRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreProductRequest $request)
    {
        try {
            \DB::beginTransaction();
            $input = $request->validated();
            
            $extension = $request->image->getClientOriginalExtension();
            $filename = $request->name.'.'.$extension;
            
            $input['image'] = $filename;
            $product = Product::create($input);

            // do upload image
            $request->image->storeAs('images/products', $filename, 'public_uploads');

            \DB::commit();

            alert()->success('Success', 'Product created successfully');
            return redirect()->route('products.index');

        } catch (\Throwable $e) {
            report($e);
            \DB::rollBack();
            
            alert()->error('Error', 'Failed to create product');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        // get list categories
        $categories = Category::pluck('name', 'id');

        return view('products.show', compact('categories', 'product'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        // get list categories
        $categories = Category::pluck('name', 'id');

        return view('products.edit', compact('categories', 'product'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \App\Http\Requests\UpdateProductRequest  $request
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateProductRequest $request, Product $product)
    {
        try {
            \DB::beginTransaction();
            $input = $request->validated();
            
            // check if new image uploaded
            if ($request->hasFile('image')) {
                $extension = $request->image->getClientOriginalExtension();
                $filename = $request->name.'.'.$extension;
                
                $input['image'] = $filename;
            }

            $product->update($input);

            // do upload image if new image exist
            if ($request->hasFile('image')) {
                $request->image->storeAs('images/products', $filename, 'public_uploads');
            }

            \DB::commit();

            alert()->success('Success', 'Product created successfully');
            return redirect()->route('products.index');

        } catch (\Throwable $e) {
            report($e);
            \DB::rollBack();
            
            alert()->error('Error', 'Failed to create product');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        try {
            $product->delete();

            alert()->success('Success', 'Product deleted successfully');
            return redirect()->route('products.index');

        } catch (\Throwable $e) {
            report($e);
            alert()->error('Error', 'Failed to delete Product');
            return redirect()->back()->withInput();
        }
    }

    /**
     * Upload image to server.
     *
     * @param  \App\Models\Product  $product
     * @return json
     */
    public function uploadImage(Request $request)
    {
        if (isset($_POST['btnSubmit'])) {
        $uploadfile = $_FILES["uploadImage"]["tmp_name"];
        $folderPath = "uploads/";
        
        if (! is_writable($folderPath) || ! is_dir($folderPath)) {
            echo "error";
            exit();
        }
        if (move_uploaded_file($_FILES["uploadImage"]["tmp_name"], $folderPath . $_FILES["uploadImage"]["name"])) {
            echo '<img src="' . $folderPath . "" . $_FILES["uploadImage"]["name"] . '">';
            exit();
        }
    }
    }
}

resources/views/products/_css.blade.php
<style type="text/css">
    /*css choose image*/
    .upload-area {
        width: 296px; 
        height: 180px;
        border: 1px solid #9eb4c4;
        height: 140px;
        border-radius: 5px;
        display: flex;
        align-items: center;
        justify-content: center;
        background-size: cover;
        background-position: center center;
    }
</style>

resources/views/products/_form.blade.php
<div class="mb-3">
    <label for="name" class="form-label">Name</label>
    <input type="text" class="form-control" id="name" placeholder="" name="name" value="{{ old('name', $product->name) }}">
    <div class="invalid-feedback">
      Please enter a message in the textarea.
    </div>
    @if ($errors->has('name'))
    <small class="text-danger">{{ $errors->first('name') }}</small>
    @endif
</div>
<div class="mb-3">
    <label for="description" class="form-label">Description</label>
    <textarea class="form-control" id="description" rows="3" name="description">{{ old('description', $product->description) }}</textarea>
    @if ($errors->has('description'))
    <small class="text-danger">{{ $errors->first('description') }}</small>
    @endif
</div>
<div class="mb-3">
    <label for="price" class="form-label">Price</label>
    <div class="input-group">
        <span class="input-group-text">Rp</span>
        <input type="text" class="form-control" aria-label="Amount (to the nearest dollar)" name="price" value="{{ old('price', $product->price) }}">
        <span class="input-group-text">.00</span>
    </div>
</div>
<div class="mb-3">
    <label for="category_id" class="form-label">Category</label>
    <select class="form-select {{isset($show) ? '' : 'select2'}}" aria-label="Default select example" name="category_id">
        <option selected>Open this select menu</option>
        @foreach ($categories as $key=>$val)
        <option value="{{$key}}" {{old('category_id', $product->category_id) == $key ? 'selected' : ''}}>{{$val}}</option>
        @endforeach
    </select>
    @if ($errors->has('category_id'))
    <small class="text-danger">{{ $errors->first('category_id') }}</small>
    @endif
</div>
<div class="mb-3">
    <label for="image" class="form-label">Image</label>
     
    <div class="upload-area d-flex flex-column" id="upload-area" style="
    background-image: url('{{ $product->image ? url('images/products').'/'.$product->image : '' }}');
    ">
        <label for="upload-image" class="btn-upload-mms"><i class="bi bi-cloud-arrow-up"></i><br></label>
        <center></center>
    </div>

    <input type="file" class="upload-input d-none" id="upload-image" name="image">
    <small class="text-muted">File type: JPEG, JPG, GIF;<br>Suggested dimension: 296 x 180 pixels</b></small>

    {{-- <div class="input-group mb-3">
        <img src="..." class="rounded float-start" alt="...">
        <input type="file" class="form-control" id="image" name="image">
        <label class="input-group-text" for="image">Upload</label>
    </div> --}}
    @if ($errors->has('image'))
    <small class="text-danger">{{ $errors->first('image') }}</small>
    @endif
</div>

<div class="pt-3 float-end">
    <a href="{{ route('products.index') }}"><button type="button" class="btn btn-light">Kembali</button></a>
    @isset($show)
    {{-- this button only on show --}}
    <a href="{{ route('products.edit', $product) }}"><button type="button" class="btn btn-primary">Edit</button></a>
    @else
    <button type="submit" class="btn btn-primary">Submit</button>
    @endif
</div>

resources/views/products/_js.blade.php
<script type="text/javascript">
    {{-- js choose image --}}
    $(document.body).on('change', '.upload-input', function (e) {
        var fuData = this;
        var FileUploadPath = $(this).val();

        if (FileUploadPath == '') {
            Swal.fire('Error','Choose image','warning');
        } else {
            var Extension = FileUploadPath.substring(FileUploadPath.lastIndexOf('.') + 1).toLowerCase();

            if (this.files && this.files[0]) {
                var reader = new FileReader();            
                reader.onload = function (e) {
                    $('#upload-area').css('background-image','url('+ e.target.result +')');
                }            
                reader.readAsDataURL(this.files[0]);
            }
        }
    });
</script>

resources/views/products/action.blade.php
<a href="{{ route('products.show', $id) }}" title="Show detail"><i class="bi bi-eye"></i></a>
<a href="{{ route('products.edit', $id) }}" title="Edit"><i class="bi bi-pencil-square"></i></a>
<a href="#" data-href="{{ route('products.destroy', $id) }}" title="Delete" class="btn-delete"><i class="bi bi-trash"></i></a>

resources/views/products/create.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent

    {{-- put custom css per page here --}}
    {{-- ckeditor for input description --}}
    <style type="text/css">
        .ck-editor__editable_inline {
            min-height: 150px;
        }
    </style>

    @include('products._css')
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    {{-- ckeditor for input description --}}
    <script src="https://cdn.ckeditor.com/ckeditor5/31.1.0/classic/ckeditor.js"></script>
    <script>
        ClassicEditor
            .create( document.querySelector( '#description' ) )
            .catch( error => {
                console.error( error );
            } );
    </script>

    @include('products._js')
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card">
                <div class="card-header">{{ __('Create Product') }}</div>

                <div class="card-body">
                    <form class="form" id="form-product" action="{{ route('products.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @include('products._form')
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/products/edit.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent

    {{-- put custom css per page here --}}
    {{-- ckeditor for input description --}}
    <style type="text/css">
        .ck-editor__editable_inline {
            min-height: 150px;
        }
    </style>

    @include('products._css')
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    {{-- ckeditor for input description --}}
    <script src="https://cdn.ckeditor.com/ckeditor5/31.1.0/classic/ckeditor.js"></script>
    <script>
        ClassicEditor
            .create( document.querySelector( '#description' ) )
            .catch( error => {
                console.error( error );
            } );
    </script>

    @include('products._js')
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card">
                <div class="card-header">{{ __('Edit Product') }}</div>

                <div class="card-body">
                    <form class="form" id="form-product" action="{{ route('products.update', $product) }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        @include('products._form')
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/products/index.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent
    
    {{-- put custom css per page here --}}
    <link rel="stylesheet" href="https://cdn.datatables.net/1.11.3/css/dataTables.bootstrap5.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/buttons/1.0.3/css/buttons.dataTables.min.css">

    <style type="text/css">
        /*image of products*/
        img.thumbnail {
            width: 100px;
        }

        /*description max line to show*/
        .text-description {
            min-width: 300px;
        }
    </style>
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    <script src="https://cdn.datatables.net/1.11.3/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.11.3/js/dataTables.bootstrap5.min.js"></script>
    <script src="https://cdn.datatables.net/buttons/1.0.3/js/dataTables.buttons.min.js"></script>
    <script src="{{ asset('vendor/datatables/buttons.server-side.js') }}"></script>

    {{-- render script datatable from yajra --}}
    {{$dataTable->scripts()}}

    {{-- delete action --}}
    <script type="text/javascript">
        $(document.body).on("click", ".btn-delete",function() {
            var url = $(this).data('href');

            Swal.fire({
                title: 'Delete product',
                text: 'Are you sure to delete this product ?',
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Delete',
            }).then((result) => {
                if (result.isConfirmed) {
                    $('#form-group-delete').attr('action', url);
                    $('#form-group-delete').submit();
                }
            });
        });
    </script>

    {{-- remove db-button class --}}
    <script type="text/javascript">
        $(document).ready(function() {
            $('.dt-button').removeClass('dt-button');
        });
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-lg-12">
            <div class="card">
                <div class="card-header">{{ __('List Products') }}</div>

                <div class="card-body" style="font-size: 0.85rem;">
                    {{-- render datatable from yajra --}}
                    {{$dataTable->table(['class' => 'table table-bordered', 'width' => '100%'])}}
                </div>
            </div>
        </div>
    </div>
</div>

{{-- form delete, populated from jquery event click button delete --}}
<form id="form-group-delete" action="" method="post" class="d-none">
    @csrf
    @method('DELETE')
</form>
@endsection

resources/views/products/show.blade.php
@extends('layouts.app')

@section('css')
    {{-- load css from layouts parent here --}}
    @parent

    {{-- put custom css per page here --}}
    @include('products._css')
@endsection

@section('js')
    {{-- load js from layouts parent here --}}
    @parent

    {{-- put custom js per page here --}}
    <script>
        $(document).ready(function() {
            // disable form input
            $('#form-product input').prop('disabled', true);
            $('#form-product select').prop('disabled', true);
            $('#form-product textarea').prop('disabled', true);
        });
    </script>
@endsection

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-10">
            <div class="card">
                <div class="card-header">{{ __('Detail Product') }}</div>

                <div class="card-body">
                    <form class="form" id="form-product" action="" method="POST" enctype="multipart/form-data">
                        @include('products._form', ['show'=>true])
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection